/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

import Ember from 'ember';

export default Ember.Component.extend({
  didInsertElement: function() {
    $(".js-example-basic-single").select2(
      {
        width: '100%',
        placeholder: "Select a queue"
      });
    var elementId = this.get("element-id");
    var prefix = this.get("prefix");

    var element = d3.select("#" + elementId);

    if (element) {
      this.get("model").forEach(function(o) {
        element.append("option").attr("value", o.get("name")).text(prefix + o.get("name"));
      });
    }
  }
});